import 'dart:io';

import 'package:test/test.dart';

import 'package:canada_post/src/models/canada_post_api_manager/canada_post_api_manager.dart';
import 'package:canada_post/src/calls/ship/price.dart';
import 'package:canada_post/src/models/mailing_scenario/mailing_scenario.dart';

Map <String, String> envVars = Platform.environment;

void main() {
  CanadaPostApiManager manager = CanadaPostApiManager(
    baseUrl: "https://ct.soa-gw.canadapost.ca/rs/",
    username: envVars["CAPO_USER"],
    password: envVars["CAPO_PASS"]
  );

  test('basic', () async {
    MailingScenario test = MailingScenario(
   // destination: UnitedStatesDestination(location: '90210')
   // destination: InternationalDestination(location: 'FR')
      destination: DomesticDestination(location: 'K1N1A7'),
      parcelCharacteristics: ParcelCharacteristics(
        dimensions: Dimensions(
          dimensions: [20.0, 20.8, 21.7]
        ),
        weight: 0.5009
      ),
      originPostalCode: envVars["CAPO_CODE"],
      options: [Option(optionCode: 'SO')],
      customerNumber: envVars["CAPO_CUST"]
    );

    PriceCaller caller = PriceCaller(manager: manager);
    buildMailingScenario(mailingScenario: test);

    Map result = await caller.shoot(test);
    print(result);
  });
}
